1#!/bin/sh
2# probe libc's inet_pton & backtrace it with ping
3
4# Installs a probe on libc's inet_pton function, that will use uprobes,
5# then use 'perf trace' on a ping to localhost asking for just one packet
6# with the a backtrace 3 levels deep, check that it is what we expect.
7# This needs no debuginfo package, all is done using the libc ELF symtab
8# and the CFI info in the binaries.
9
10# SPDX-License-Identifier: GPL-2.0
11# Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
12
13. $(dirname $0)/lib/probe.sh
14. $(dirname $0)/lib/probe_vfs_getname.sh
15
16libc=$(grep -w libc /proc/self/maps | head -1 | sed -r 's/.*[[:space:]](\/.*)/\1/g')
17nm -Dg $libc 2>/dev/null | fgrep -q inet_pton || exit 254
18
19event_pattern='probe_libc:inet_pton(\_[[:digit:]]+)?'
20
21add_libc_inet_pton_event() {
22
23	event_name=$(perf probe -f -x $libc -a inet_pton 2>&1 | tail -n +2 | head -n -5 | \
24			grep -P -o "$event_pattern(?=[[:space:]]\(on inet_pton in $libc\))")
25
26	if [ $? -ne 0 -o -z "$event_name" ] ; then
27		printf "FAIL: could not add event\n"
28		return 1
29	fi
30}
31
32trace_libc_inet_pton_backtrace() {
33
34	expected=`mktemp -u /tmp/expected.XXX`
35
36	echo "ping[][0-9 \.:]+$event_name: \([[:xdigit:]]+\)" > $expected
37	echo ".*inet_pton\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
38	case "$(uname -m)" in
39	s390x)
40		eventattr='call-graph=dwarf,max-stack=4'
41		echo "text_to_binary_address.*\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
42		echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
43		echo "(__GI_)?getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
44		echo "main\+0x[[:xdigit:]]+[[:space:]]\(.*/bin/ping.*\)$" >> $expected
45		;;
46	ppc64|ppc64le)
47		eventattr='max-stack=4'
48		echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
49		echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
50		echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
51		;;
52	*)
53		eventattr='max-stack=3'
54		echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
55		echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
56		;;
57	esac
58
59	perf_data=`mktemp -u /tmp/perf.data.XXX`
60	perf_script=`mktemp -u /tmp/perf.script.XXX`
61
62	# Check presence of libtraceevent support to run perf record
63	skip_no_probe_record_support "$event_name/$eventattr/"
64	[ $? -eq 2 ] && return 2
65
66	perf record -e $event_name/$eventattr/ -o $perf_data ping -6 -c 1 ::1 > /dev/null 2>&1
67	# check if perf data file got created in above step.
68	if [ ! -e $perf_data ]; then
69		printf "FAIL: perf record failed to create \"%s\" \n" "$perf_data"
70		return 1
71	fi
72	perf script -i $perf_data | tac | grep -m1 ^ping -B9 | tac > $perf_script
73
74	exec 3<$perf_script
75	exec 4<$expected
76	while read line <&3 && read -r pattern <&4; do
77		[ -z "$pattern" ] && break
78		echo $line
79		echo "$line" | grep -E -q "$pattern"
80		if [ $? -ne 0 ] ; then
81			printf "FAIL: expected backtrace entry \"%s\" got \"%s\"\n" "$pattern" "$line"
82			return 1
83		fi
84	done
85
86	# If any statements are executed from this point onwards,
87	# the exit code of the last among these will be reflected
88	# in err below. If the exit code is 0, the test will pass
89	# even if the perf script output does not match.
90}
91
92delete_libc_inet_pton_event() {
93
94	if [ -n "$event_name" ] ; then
95		perf probe -q -d $event_name
96	fi
97}
98
99# Check for IPv6 interface existence
100ip a sh lo | fgrep -q inet6 || exit 2
101
102skip_if_no_perf_probe && \
103add_libc_inet_pton_event && \
104trace_libc_inet_pton_backtrace
105err=$?
106rm -f ${perf_data} ${perf_script} ${expected}
107delete_libc_inet_pton_event
108exit $err
109